import argparse
import logging
import socket
import traceback

hostname = socket.gethostname()
logging.basicConfig(filename=hostname+'-server6.log', encoding='utf-8', format='%(asctime)s %(message)s', level=logging.DEBUG)

parser = argparse.ArgumentParser()
parser.add_argument("addr", help="IPv6 address to use for source")
parser.add_argument("multicast_group", help="Multicast IPv6 address to use for destination")

args = parser.parse_args()
logging.info('host %s will send to %s with source address %s', hostname, args.multicast_group, args.addr)

ttl = 12
sock = socket.socket(socket.AF_INET6, socket.SOCK_DGRAM)
sock.setsockopt(socket.IPPROTO_IPV6, socket.IPV6_MULTICAST_HOPS, ttl)
sock.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)

sock.bind((args.addr, 10000))
try:
    while True:
        input_msg = input('msg --> ')
        try:
            sock.sendto(input_msg.encode("utf-8"), (args.multicast_group, 10000))
            logging.info('%s sent %s', hostname, input_msg)
        except Exception:
            traceback.print_exc()
            continue

finally:
    sock.close()
